/*
 *	app.h
 *
 *	n[YRbgvC[
 *
 *	* Sun Mar 07 06:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include <clip.h>

#define CPU_CLOCK	3000000
#define PSG_CLOCK	1500000
#define INT_INTERVAL	  81920

#define MAX_TRACK	64

typedef struct _DRIVER {
	/*{{CAEgŒ*/
	Z80 z80;
	unsigned char mem[0x10000];
	/*}}CAEgŒ*/
	AY38910 psg[3];
	//
	int track[MAX_TRACK];
	int num_track;
	//
	int int_progress;
} DRIVER;
extern DRIVER g_driver;

void z80_write(Z80* z80, unsigned short addr, unsigned char data);

typedef struct _ROMSET {
	int year;				/* N */
	const char* name;			/* Q[ */
	const char* file;			/* ROMZbgt@C (NULL:Ή) */
	const ROM* program_roms;		/* vOROM */
	int num_program_roms;			/* vOROM */
	int track[MAX_TRACK];			/* egbÑR}hԍ */
	void (*init1)(DRIVER* driver);		/* ZbgȌ[` */
	void (*init2)(DRIVER* driver);		/* Zbg̏[` */
} ROMSET;

int file_sel(DRIVER* driver, int i_file);
void track_sel(DRIVER* driver, const ROMSET* romset);
void driver_play(DRIVER* driver, const ROMSET* romset, int reqno);
int stream_callback(short wbuff[], int param);
void driver_mix(DRIVER* driver, short wbuff[/*WSGBUFLEN*/]);
void driver_mix2(DRIVER* driver, short wbuff[/*WSGBUFLEN*/]);

void ay38910_mix3(AY38910 ay[3], short wbuff[/*count*/], int count);
