/*
 *	fram.c
 *
 *	n[YRbgvC[
 *
 *	* Sun Mar 07 06:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

void
z80_write(Z80* z80, unsigned short addr, unsigned char data)
{
	DRIVER* driver = (DRIVER*)z80;
	unsigned char* mem = driver->mem;

	if(addr >= 0x4000 && addr <= 0x47ff) {
		mem[addr] = data;
		return;
	}

	switch(addr) {
	case 0x4800: ay38910_address(&driver->psg[0], data); return;
	case 0x4801: ay38910_write  (&driver->psg[0], data); return;
	case 0x4802: ay38910_address(&driver->psg[1], data); return;
	case 0x4803: ay38910_write  (&driver->psg[1], data); return;
	case 0x4804: ay38910_address(&driver->psg[2], data); return;
	case 0x4805: ay38910_write  (&driver->psg[2], data); return;
	}
}

void
ay38910_mix3(AY38910 ay[3], short wbuff[/*count*/], int count)
{
	DDA clock_progress;
	int cycle;
	int sample;

	clock_progress = ay->clock_progress; /* ̂߁Aꎞo */
	while(count > 0) {
		/* o߃TCN߂܂B */
		cycle = clock_progress.u;
		clock_progress.d += clock_progress.n;
		if(clock_progress.d >= 0) {
			clock_progress.d -= SPEAKER_FREQUENCY;
			cycle++;
		}

		/* 1Tv~LVO܂B */
		sample = ay38910_process(&ay[0], cycle)		/* t11.5bit */
		       + ay38910_process(&ay[1], cycle)		/* t11.5bit */
		       + ay38910_process(&ay[2], cycle);	/* t11.5bit */
		sample <<= 16 - 11/**/;

		/* NbsOĊi[܂B */
		if(sample < -0x7fff) sample = -0x7fff;
		if(sample >  0x7fff) sample =  0x7fff;
		*wbuff++ = sample;

		/* cTv炵܂B */
		count--;
	}
	ay->clock_progress = clock_progress; /* ߂BYꂸȂ!! */
}
